﻿using System.Threading.Tasks;
using FarmmapsApi;
using FarmmapsApi.Models;
using Microsoft.Extensions.Configuration;
using Microsoft.Extensions.DependencyInjection;
using Microsoft.Extensions.Logging;
using Microsoft.Extensions.Logging.Console;

namespace FarmmapsApiSamples
{
    class Program
    {
        private static async Task Main(string[] args)
        {
            IConfiguration config = new ConfigurationBuilder()
                .AddJsonFile("appsettings.json", false, true)
                .Build();

            var configuration = config.Get<Configuration>();

            var serviceProvider = new ServiceCollection()
                .AddLogging(opts => opts
                    .AddConsole(c =>
                    {
                        c.IncludeScopes = false;
                        c.Format = ConsoleLoggerFormat.Default;
                    })
                    .AddFilter("System.Net.Http", LogLevel.Warning))
                .AddFarmmapsServices(configuration)
                .AddSingleton<IApp, NbsApp>()
                .BuildServiceProvider();

            await serviceProvider.GetService<IApp>().RunAsync();
        }
    }
}